function varargout = Hamilton(varargin)
% HAMILTON M-file for Hamilton.fig

% Last Modified by GUIDE v2.5 27-May-2012 13:02:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Hamilton_OpeningFcn, ...
    'gui_OutputFcn',  @Hamilton_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before Hamilton is made visible.
function Hamilton_OpeningFcn(hObject, eventdata, handles, varargin)
global HamiltonDir PhSpGeoDir
HamiltonDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(HamiltonDir)
if isdeployed
%do nothing
else
    path([PhSpGeoDir,'/AddedODEsolver/bin'], path);
    path([PhSpGeoDir,'/Util'], path);
    path([PhSpGeoDir,'/Util/Multicore'], path);
    path([HamiltonDir,'/Help'], path);
    path(HamiltonDir, path);
end
%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
    'HelpScript'];
set(handles.figure1,'HelpFcn',Hfcn);
cshelp(handles.figure1);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
    'set(gcbo,''CSHelpMode'',''off''); ' ...
    'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
    'set(gcbo,''CSHelpMode'',''on''); ' ...  
    'end'];     
set(handles.figure1,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ColorFont
handles.output = hObject;

if ~isnan(findstr(HamiltonDir, 'Slave'))
    set(handles.pushbutton_StartSlave, 'Visible', 'on')
    set(handles.pushbutton_Calculate, 'Visible', 'off')
else
    cd ..
    if exist('multicorefiles')
        rmdir('multicorefiles','s')
    end
    cd(HamiltonDir)
end

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
%curdir = list{dim(1,1), dim(1,2)};
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figure1, 'Name', curdir)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(HamiltonDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(HamiltonDir)
if get(handles.popupmenuODE,'Value') == 3
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'on')
end

if get(handles.popupHamilton,'Value') == 1
    set(handles.I3_o,'Enable','on')
    set(handles.I3_FMFT,'Enable','on')
    set(handles.Step_FMI3,'Enable','on')
    set(handles.edit_eps,'Enable','on')
elseif get(handles.popupHamilton,'Value') == 2
    set(handles.I3_o,'Enable','on')
    set(handles.I3_FMFT,'Enable','on')
    set(handles.Step_FMI3,'Enable','on')
    set(handles.edit_eps,'Enable','on')
elseif get(handles.popupHamilton,'Value') == 3
    set(handles.I3_o,'Enable','off')
    set(handles.I3_FMFT,'Enable','off')
    set(handles.Step_FMI3,'Enable','off')
    set(handles.edit_eps,'Enable','off')
end

if str2num(get(handles.step_1,'String')) == 0
    set(handles.x_fin,'Enable','off')
end
if str2num(get(handles.step_2,'String')) == 0
    set(handles.y_fin,'Enable','off')
end    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(HamiltonDir, 'Slave'))
    Totalbar = waitbar(0,'Please wait..., HAMILTON is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Hamilton_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
global HamiltonDir PhSpGeoDir
if ~isnan(findstr(HamiltonDir, 'Slave'))
%do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on')     
        cd(HamiltonDir)
        InitStructure
        cd ..        
        save('Setting.mat', '-struct', 'InitStr')
        cd(HamiltonDir)
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                        Panel: Hamiltonian
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on selection change in popupHamilton.
function popupHamilton_Callback(hObject, eventdata, handles)
Disable_all
if get(handles.popupHamilton,'Value') == 1
    set(handles.I3_o,'Enable','on')
    set(handles.I3_FMFT,'Enable','on')
    set(handles.Step_FMI3,'Enable','on')
    set(handles.edit_eps,'Enable','on')
elseif get(handles.popupHamilton,'Value') == 2
    set(handles.I3_o,'Enable','on')
    set(handles.I3_FMFT,'Enable','on')
    set(handles.Step_FMI3,'Enable','on')
    set(handles.edit_eps,'Enable','on')
elseif get(handles.popupHamilton,'Value') == 3
    set(handles.I3_o,'Enable','off')
    set(handles.I3_o,'String','0')
    set(handles.I3_FMFT,'Enable','off')
    set(handles.Step_FMI3,'Enable','off')
    set(handles.edit_eps,'Enable','off')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                        Panel: ODE solver
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popupmenuODE_Callback(hObject, eventdata, handles)
contents = get(hObject,'String');
item = get(hObject,'Value');
ODE = char(contents(item));

if  (strcmp(ODE, 'IRKGauss') == 1)   
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'on')
else
    set(handles.opt_ODE, 'Visible', 'on')
    set(handles.opt_IRK, 'Visible', 'off')
end
Disable_all

function step_ODE_Callback(hObject, eventdata, handles)
if isempty(get(gcbo,'String'))
    set(handles.step_ODE,'String','0.01')
end

function step_IRK_Callback(hObject, eventdata, handles)
if isempty(get(gcbo,'String'))
    set(handles.step_IRK,'String','0.05')
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Panel: Time-Frequency Analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function I1_FMFT_Callback(hObject, eventdata, handles)

function I2_FMFT_Callback(hObject, eventdata, handles)

function I3_FMFT_Callback(hObject, eventdata, handles)

function edit_nfreq_Callback(hObject, eventdata, handles)

function edit_fromfreq_Callback(hObject, eventdata, handles)

function edit_tofreq_Callback(hObject, eventdata, handles)

function popupmenu_FMFT_flag_Callback(hObject, eventdata, handles)


function pushbutton_FFT_Callback(hObject, eventdata, handles)
hh = helpdlg(sprintf(['Please wait, HAMILTON is calculating.']),'Fast Fourier Transform');
global epsilon PhSpGeoDir
epsilon = str2num(get(handles.edit_eps,'String'));
contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
tau_total = str2num(get(handles.edit_time,'String'));
OutStep = str2num(get(handles.step_ODE,'String'));
Rel_Tol = str2num(get(handles.RelTol,'String'));
Abs_Tol = str2num(get(handles.AbsTol,'String'));
Init_Step = str2num(get(handles.InStep,'String'));
Max_Step = str2num(get(handles.MaxStep,'String'));
freq_max = 2*pi/OutStep;
freq_max = 2*pi*freq_max;
I1_o = str2num(get(handles.I1_FMFT,'String'));
I2_o = str2num(get(handles.I2_FMFT,'String'));
I3_o = str2num(get(handles.I3_FMFT,'String'));
Xo = [0;  0;  0;  I1_o;  I2_o;  I3_o];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if get(handles.popupHamilton,'Value') == 1
    DiffEquation = 'FGL';
elseif get(handles.popupHamilton,'Value') == 2
    DiffEquation = 'FGLmod';
elseif get(handles.popupHamilton,'Value') == 3
    DiffEquation = 'ERSD';        
end
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(hh)
        return
    end
%-----------------------------
if (strcmp(ODE, 'IRKGauss') == 1)

    opt.method = 6;
    opt.nstep = tau_total/OutStep;
    [tau,W] = eval([ODE, '(@',DiffEquation,', [0, tau_total], Xo, opt)']);
else
    OutStep_string = num2str(OutStep);
    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);
    [tau,W] = eval([ODE, '(''',DiffEquation,''', [0 :',OutStep_string,': tau_total], Xo, options)']);
end
close(hh)
d = size(W(:,1),1);
nump = 2^(floor(log2(d)));    
freq = [0 :freq_max/nump: freq_max];
freq(nump) = [];    
freq = (freq - freq_max/2)/(2*pi);
valCheck = get(handles.check_log,'Value');    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%                     Plot FFT of I1   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
F = fft((W(:,4).*cos(W(:,1)) + i*W(:,4).*sin(W(:,1))), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title({'Fast Fourier Transform for \itI_1  \phi_1'})    
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%                     Plot FFT of I1   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
F = fft((W(:,5).*cos(W(:,2)) + i*W(:,5).*sin(W(:,2))), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title({'Fast Fourier Transform for \itI_2  \phi_2'})    
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%                     Plot FFT of I3   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
F = fft((W(:,6).*cos(W(:,3)) + i*W(:,6).*sin(W(:,3))), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title({'Fast Fourier Transform for \itI_3  \phi_3'})    
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)

function pushbutton_FMFT_Callback(hObject, eventdata, handles)
hh = helpdlg(sprintf('Please wait, HAMILTON is calculating.'),...
     'Frequency Analysis');
global epsilon PhSpGeoDir HamiltonDir
cd(HamiltonDir)
epsilon = str2num(get(handles.edit_eps,'String'));
contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
tau_total = str2num(get(handles.edit_time,'String'));
OutStep = str2num(get(handles.step_ODE,'String'));
Rel_Tol = str2num(get(handles.RelTol,'String'));
Abs_Tol = str2num(get(handles.AbsTol,'String'));
Init_Step = str2num(get(handles.InStep,'String'));
Max_Step = str2num(get(handles.MaxStep,'String'));
I1_o = str2num(get(handles.I1_FMFT,'String'));
I2_o = str2num(get(handles.I2_FMFT,'String'));
I3_o = str2num(get(handles.I3_FMFT,'String'));
Xo = [0;  0;  0;  I1_o;  I2_o;  I3_o];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if get(handles.popupHamilton,'Value') == 1
    DiffEquation = 'FGL';
elseif get(handles.popupHamilton,'Value') == 2
    DiffEquation = 'FGLmod';
elseif get(handles.popupHamilton,'Value') == 3
    DiffEquation = 'ERSD';        
end
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(hh)
        return
    end
%-----------------------------
if (strcmp(ODE, 'IRKGauss') == 1)
    opt.method = 6;
    opt.nstep = tau_total/OutStep;
    [tau,W] = eval([ODE, '(@',DiffEquation,', [0, tau_total], Xo, opt)']);
else
    OutStep_string = num2str(OutStep);
    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);
    [tau,W] = eval([ODE, '(''',DiffEquation,''', [0 :',OutStep_string,': tau_total], Xo, options)']);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
min_f = num2str(1000*str2num(get(handles.edit_fromfreq,'String')),'%6.12f');
max_f = num2str(1000*str2num(get(handles.edit_tofreq,'String')),'%6.12f');    
flag_FMFT = num2str(get(handles.popupmenu_FMFT_flag,'Value'));    
nfreq = get(handles.edit_nfreq,'String');
data_sep = num2str(100000*OutStep);
d = size(W(:,1),1);    
ndata = num2str(2^(floor(log2(d))));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct1.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act1x = W(:,4).*cos(W(:,1));
Act1y = W(:,4).*sin(W(:,1));
fid = fopen(['inputAct1.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act1x'; Act1y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct2.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act2x = W(:,5).*cos(W(:,2));
Act2y = W(:,5).*sin(W(:,2));
fid = fopen(['inputAct2.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act2x'; Act2y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct3.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act3x = W(:,6).*cos(W(:,3));
Act3y = W(:,6).*sin(W(:,3));
fid = fopen(['inputAct3.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act3x'; Act3y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
    data_sep,' ',ndata,' ','<inputAct1.txt',' ','>FMFT_of_Act1.txt'];    
eval(cmd_string)    
delete inputAct1.txt    
cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
    data_sep,' ',ndata,' ','<inputAct2.txt',' ','>FMFT_of_Act2.txt'];    
eval(cmd_string)    
delete inputAct2.txt    
cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
    data_sep,' ',ndata,' ','<inputAct3.txt',' ','>FMFT_of_Act3.txt'];    
eval(cmd_string)    
delete inputAct3.txt
close(hh);

[Freq  Amp Phase] = textread('FMFT_of_Act1.txt', '%f %f %f', 'headerlines', 4);
figure
bar(Freq/1000,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
title('FMFT for Action 1')    
xlabel('Frequency', 'FontSize',10)

[Freq  Amp Phase] = textread('FMFT_of_Act2.txt', '%f %f %f', 'headerlines', 4);
figure
bar(Freq/1000,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
title('FMFT for Action 2')    
xlabel('Frequency', 'FontSize',10)

[Freq  Amp Phase] = textread('FMFT_of_Act3.txt', '%f %f %f', 'headerlines', 4);
figure
bar(Freq/1000,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
title('FMFT for Action 3')    
xlabel('Frequency', 'FontSize',10)

%{
figure
    subplot(1,3,1); polar(W(:,1), W(:,4))
    title('\itI_1  \phi_1')
    subplot(1,3,2); polar(W(:,2) ,W(:,5))
    title('\itI_2  \phi_2')
    subplot(1,3,3); polar(W(:,3) ,W(:,6))
    title('\itI_3  \phi_3')
%}
    
% --- Executes on button press in pushbutton_wavelet.
function pushbutton_wavelet_Callback(hObject, eventdata, handles)
        h = helpdlg(sprintf(['Please wait, HAMILTON is calculating.']),...
        'Wavelet transform');
global epsilon PhSpGeoDir min_freq max_freq eta sigma2 fourier_factor
epsilon = str2num(get(handles.edit_eps,'String'));
contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));    
min_freq = str2num(get(handles.edit_min_freq,'String'));
max_freq = str2num(get(handles.edit_max_freq,'String'));
eta = 1;
sigma2 = (2*pi*str2num(get(handles.edit_Variance,'String')))^2;
fourier_factor = 2/(eta + sqrt(2/sigma2 + eta^2));
OutStep = str2num(get(handles.step_ODE, 'String'));
Rel_Tol = str2num(get(handles.RelTol,'String'));
Abs_Tol = str2num(get(handles.AbsTol,'String'));
Init_Step = str2num(get(handles.InStep,'String'));
Max_Step = str2num(get(handles.MaxStep,'String'));
tau_total = str2num(get(handles.edit_time,'String'));
I1_o = str2num(get(handles.I1_FMFT,'String'));
I2_o = str2num(get(handles.I2_FMFT,'String'));
I3_o = str2num(get(handles.I3_FMFT,'String'));
Xo = [0;  0;  0;  I1_o;  I2_o;  I3_o];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if get(handles.popupHamilton,'Value') == 1
    DiffEquation = 'FGL';
elseif get(handles.popupHamilton,'Value') == 2
    DiffEquation = 'FGLmod';
elseif get(handles.popupHamilton,'Value') == 3
    DiffEquation = 'ERSD';        
end
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(h)
        return
    end
%-----------------------------
if (strcmp(ODE, 'IRKGauss') == 1)
    opt.method = 6;
    opt.nstep = tau_total/OutStep;
    [tau,W] = eval([ODE, '(@',DiffEquation,', [0, tau_total], Xo, opt)']);
else
    OutStep_string = num2str(OutStep);
    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);
    [tau,W] = eval([ODE, '(''',DiffEquation,''', [0 :',OutStep_string,': tau_total], Xo, options)']);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
signal = W(:,4).*cos(W(:,1)) + i*W(:,4).*sin(W(:,1));
[wt, Frequency] = wavelet_transf(signal, OutStep/2/pi);
spectrum = (abs(wt)).^2;
if spectrum < 1000*eps
    spectrum = 1000*eps;
end
close(h)

figure
colormap(gray)
contour(tau, Frequency, spectrum)
xlabel('Revolution number', 'FontSize',12), ylabel('Frequency \times 1000', 'FontSize',12),
title('Frequency for \itI_1 - \phi_1', 'FontSize',12)    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Panel: Frequency Modulation Indicator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function I3_o_Callback(hObject, eventdata, handles)
if str2num(get(handles.I3_o,'String')) == 0
    set(handles.Step_FMI3,'Enable','off')
else
    set(handles.Step_FMI3,'Enable','on')
end
Disable_all

% --- Executes on button press in pushbutton_Calculate.
function pushbutton_Calculate_Callback(hObject, eventdata, handles)
Disable_all
set(handles.pushbutton_Calculate,'Enable','off')
global HamiltonDir freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 I1 I2
x_init = str2num(get(handles.x_in,'String'));
y_init = str2num(get(handles.y_in,'String'));
x_fin = str2num(get(handles.x_fin,'String'));
y_fin = str2num(get(handles.y_fin,'String'));
numstep_x = str2num(get(handles.step_1,'String'));
numstep_y = str2num(get(handles.step_2,'String'));
row_tot = numstep_y + 1;
col_tot = numstep_x + 1;
ext_tot = max(row_tot, col_tot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
global HamiltonDir PhSpGeoDir
if ~isnan(findstr(HamiltonDir, 'Slave'))
% do nothing
else
    Totalbar = waitbar(0,'Please wait..., HAMILTON is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(Totalbar)
        set(handles.pushbutton_Calculate,'Enable','on')
        return
    end
%-----------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display(['    STARTING COMPUTATION with ',ODE,'!!!'])
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,4);
for ext = 1:ext_tot
    subcell{1,1} = [ext];
    subcell{1,2} = [handles];
    subcell{1,3} = [Totalbar];
    subcell{1,4} = [begin];      
    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(HamiltonDir)

warning('off')
resultCell = startmulticoremaster(@paralfor, parameterCell, '../multicorefiles');
warning('on')
%---------------------- End multicore -----------------------------------

freq_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    freq_1 = [freq_1; resultCell{1,k}(1,:)];
end
freq_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    freq_2 = [freq_2; resultCell{1,k}(2,:)];
end
freq_3 = [resultCell{1,1}(3,:)];
for k = 2 : ext_tot
    freq_3 = [freq_3; resultCell{1,k}(3,:)];
end
FMI_1 = [resultCell{1,1}(4,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(4,:)];
end
FMI_2 = [resultCell{1,1}(5,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(5,:)];
end
FMI_3 = [resultCell{1,1}(6,:)];
for k = 2 : ext_tot
    FMI_3 = [FMI_3; resultCell{1,k}(6,:)];
end

if row_tot <= col_tot
    freq_1 = freq_1';
    freq_2 = freq_2';
    freq_3 = freq_3';
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
    FMI_3 = FMI_3';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    save freq1.dat freq_1 -ascii
    save freq2.dat freq_2 -ascii
    save freq3.dat freq_3 -ascii
    save FMI1.dat FMI_1 -ascii
    save FMI2.dat FMI_2 -ascii
    save FMI3.dat FMI_3 -ascii
    delete *.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set(handles.pushbutton_freq, 'Enable', 'on')
if (numstep_x ~= 0) & (numstep_y ~= 0)
    set(handles.pushbutton_level, 'Enable', 'on')
end
set(handles.pushbutton_FMI, 'Enable', 'on')
set(handles.pushbutton_ratio, 'Enable', 'on')
I1 = x_init : (x_fin - x_init)/numstep_x : x_fin;
I2 = y_init : (y_fin - y_init)/numstep_y : y_fin;

display('-------------------------------------------------------------------')
display(['            FINISH with ',ODE,'!!!'])
toc
display('###################################################################')
set(handles.count,'String', '0');
set(handles.pushbutton_Calculate,'Enable','on')

% --- Executes on button press in pushbutton_freq.
function pushbutton_freq_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
numstep_x = str2num(get(handles.step_1,'String'));
numstep_y = str2num(get(handles.step_2,'String'));
if (numstep_x == 0) & (numstep_y > 0)
    figure
    hold on
    plot(I2, freq_1(:,:),'r')
    plot(I2, freq_2(:,:),'k')
    plot(I2, freq_3(:,:),'b')
    legend('Frequency 1','Frequency 2', 'Frequency 3')
    hold off
    title(['Frequencies \times1000 \itvs \itI_2 \rmwith \itI_1 = \rm',get(handles.x_in,'String')],'FontSize',12)
    xlabel('\itI_2', 'FontSize',14), ylabel('Frequencies', 'FontSize',14)
elseif (numstep_y == 0) & (numstep_x > 0)
    figure
    hold on
    plot(I1, freq_1(:,:),'r')
    plot(I1, freq_2(:,:),'k')
    plot(I1, freq_3(:,:),'b')
    legend('Frequency 1','Frequency 2', 'Frequency 3')
    hold off
    title(['Frequencies \times1000 \itvs \itI_1 \rmwith \itI_2 = \rm',get(handles.y_in,'String')],'FontSize',12)
    xlabel('\itI_1', 'FontSize',14), ylabel('Frequencies', 'FontSize',14)
else (numstep_x > 0) & (numstep_y > 0);
    figure
    colormap(gray)
    surfc(I1, I2, freq_1, 'FaceColor', 'interp', 'LineStyle', ':');
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title('Frequency 1', 'FontSize',14)
    figure
    colormap(gray)
    surfc(I1, I2, freq_2, 'FaceColor', 'interp', 'LineStyle', ':');
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title('Frequency 2', 'FontSize',14)

    figure
    colormap(gray)
    surfc(I1, I2, freq_3, 'FaceColor', 'interp', 'LineStyle', ':');
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title('Frequency 3', 'FontSize',14)      
end

% --- Executes on button press in pushbutton_level.
function pushbutton_level_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
figure
[C,h] = contour(I1,I2, freq_1);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 1', 'FontSize',14)

figure
[C,h] = contour(I1,I2, freq_2);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 2', 'FontSize',14)

figure
[C,h] = contour(I1,I2, freq_3);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 3', 'FontSize',14)

% --- Executes on button press in pushbutton_FMI.
function pushbutton_FMI_Callback(hObject, eventdata, handles)
global FMI_1 FMI_2 FMI_3 I1 I2
numstep_x = str2num(get(handles.step_1,'String'));
numstep_y = str2num(get(handles.step_2,'String'));
if (numstep_x == 0) & (numstep_y > 0)
    if str2num(get(handles.Step_FMI1,'String')) > 0;
        figure
        plot(I2, FMI_1(:,:))
        title(['FMI 1 \itvs \itI_2 \rmwith \itI_1 = ', get(handles.x_in,'String')], 'FontSize',12)
        xlabel('\itI_2', 'FontSize',14), ylabel('FMI 1', 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI2,'String')) > 0;
        figure
        plot(I2, FMI_2(:,:))
        title(['FMI 2 \itvs \itI_2 \rmwith \itI_1 = ', get(handles.x_in,'String')], 'FontSize',12)
        xlabel('\itI_2', 'FontSize',14), ylabel('FMI 2', 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI3,'String')) > 0;
        figure
        plot(I2, FMI_3(:,:))
        title(['FMI 3 \itvs \itI_2 \rmwith \itI_1 = ', get(handles.x_in,'String')], 'FontSize',12)
        xlabel('\itI_2', 'FontSize',14), ylabel('FMI 3', 'FontSize',14)
    end
elseif (numstep_y == 0) & (numstep_x > 0)
    if str2num(get(handles.Step_FMI1,'String')) > 0;
        figure
        plot(I1, FMI_1(:,:))
        title(['FMI 1 \itvs \itI_1 \rmwith \itI_2 = ', get(handles.y_in,'String')], 'FontSize',12)
        xlabel('\itI_1', 'FontSize',14), ylabel('FMI 1', 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI2,'String')) > 0;
        figure
        plot(I1, FMI_2(:,:))
        title(['FMI 2 \itvs \itI_1 \rmwith \itI_2 = ', get(handles.y_in,'String')], 'FontSize',12)
        xlabel('\itI_1', 'FontSize',14), ylabel('FMI 2', 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI3,'String')) > 0;
        figure
        plot(I1, FMI_3(:,:))
        title(['FMI 3 \itvs \itI_1 \rmwith \itI_2 = ', get(handles.y_in,'String')], 'FontSize',12)
        xlabel('\itI_1', 'FontSize',14), ylabel('FMI 3', 'FontSize',14)
    end
else (numstep_x > 0) & (numstep_y > 0);
    if str2num(get(handles.Step_FMI1,'String')) > 0;
        figure
        colormap(gray)
        surf(I1, I2, FMI_1, 'FaceColor', 'interp', 'LineStyle', 'none');
        view(2)
        xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
        title({'FMI 1'}, 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI2,'String')) > 0;
        figure
        colormap(gray)
        surf(I1, I2, FMI_2, 'FaceColor', 'interp', 'LineStyle', 'none');
        view(2)
        xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
        title({'FMI 2'}, 'FontSize',14)
    end

    if str2num(get(handles.Step_FMI3,'String')) > 0;
        figure
        colormap(gray)
        surf(I1, I2, FMI_3, 'FaceColor', 'interp', 'LineStyle', 'none');
        view(2)
        xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
        title({'FMI 3'}, 'FontSize',14)
    end
end


% --- Executes on button press in pushbutton_ratio.
function pushbutton_ratio_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
freq_ratio_12(:,:) = abs(freq_1(:,:)./freq_2(:,:));
freq_ratio_31(:,:) = abs(freq_3(:,:)./freq_1(:,:));
freq_ratio_32(:,:) = abs(freq_3(:,:)./freq_2(:,:));
numstep_x = str2num(get(handles.step_1,'String'));
numstep_y = str2num(get(handles.step_2,'String'));
if (numstep_x == 0) & (numstep_y > 0)
    figure
    hold on
    plot(I2, freq_ratio_12,'r')
    plot(I2, freq_ratio_31,'k')
    plot(I2, freq_ratio_32,'b')
    legend('Frequency 1 over 2','Frequency 3 over 1', 'Frequency 3 over 2')
    hold off
    title(['Frequency ratios \itvs \itI_2 \rmwith \itI_1 = \rm',get(handles.x_in,'String')],'FontSize',12)
    xlabel('\itI_2', 'FontSize',14), ylabel('Frequency ratios', 'FontSize',14) 
elseif (numstep_y == 0) & (numstep_x > 0)
    figure
    hold on
    plot(I1, freq_ratio_12,'r')
    plot(I1, freq_ratio_31,'k')
    plot(I1, freq_ratio_32,'b')
    legend('Frequency 1 over 2','Frequency 3 over 1', 'Frequency 3 over 2')
    hold off
    title(['Frequency ratios \itvs \itI_1 \rmwith \itI_2 = \rm',get(handles.y_in,'String')],'FontSize',12)
    xlabel('\itI_1', 'FontSize',14), ylabel('Frequency ratios', 'FontSize',14)
else (numstep_x > 0) & (numstep_y > 0); 
    figure
    [C,h] = contour(I1,I2, freq_ratio_12);
    clabel(C,h);
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'Level lines of the Frequency 1 over 2'}, 'FontSize',14)
      
    figure
    [C,h] = contour(I1,I2, freq_ratio_31);
    clabel(C,h);
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'Level lines of the Frequency 3 over 1'}, 'FontSize',14)    

    figure
    [C,h] = contour(I1,I2, freq_ratio_32);
    clabel(C,h);
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'Level lines of the Frequency 3 over 2'}, 'FontSize',14)
end

function x_in_Callback(hObject, eventdata, handles)
Disable_all

function x_fin_Callback(hObject, eventdata, handles)
Disable_all

function y_in_Callback(hObject, eventdata, handles)
Disable_all

function y_fin_Callback(hObject, eventdata, handles)
Disable_all

function step_1_Callback(hObject, eventdata, handles)
Disable_all
if str2num(get(gcbo,'String')) == 0
    set(handles.x_fin,'Enable','off')
    if str2num(get(handles.step_2,'String')) == 0
        warndlg('At least one of the two step numbers must be a positive integer');
        set(handles.step_2,'String','1')
        set(handles.y_fin,'Enable','on')
    end
else
    set(handles.x_fin,'Enable','on')
end

function step_2_Callback(hObject, eventdata, handles)
Disable_all
if str2num(get(gcbo,'String')) == 0
    set(handles.y_fin,'Enable','off')
    if str2num(get(handles.step_1,'String')) == 0
        warndlg('At least one of the two step numbers must be a positive integer');
        set(handles.step_1,'String','1')
        set(handles.x_fin,'Enable','on')
    end    
else
    set(handles.y_fin,'Enable','on')
end

function freq1_min_Callback(hObject, eventdata, handles)
Disable_all

function freq1_max_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI1_Callback(hObject, eventdata, handles)
Disable_all

function freq2_min_Callback(hObject, eventdata, handles)
Disable_all

function freq2_max_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI2_Callback(hObject, eventdata, handles)
Disable_all

function freq3_min_Callback(hObject, eventdata, handles)
Disable_all

function freq3_max_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI3_Callback(hObject, eventdata, handles)
Disable_all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function count_Callback(hObject, eventdata, handles)

function count_CreateFcn(hObject, eventdata, handles)

function pushbutton_StartSlave_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)
startmulticoreslave('../multicorefiles')

%%%%%%%%%%%%%%%%%%% MENU %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function savesetting_Callback(hObject, eventdata, handles)
% do nothing

function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Save_now_Callback(hObject, eventdata, handles)
global HamiltonDir PhSpGeoDir
InitStructure
cd(HamiltonDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(HamiltonDir)

function save_fig_Callback(hObject, eventdata, handles)
if isempty(get(0,'CurrentFigure'))
%    set(handles.save_eps,'Enable','off')
    set(handles.save_pdf,'Enable','off')
    set(handles.save_png,'Enable','off')
    set(handles.jpeg2eps,'Enable','off')
else
%    set(handles.save_eps,'Enable','on')
    set(handles.save_pdf,'Enable','on')
    set(handles.save_png,'Enable','on')
    set(handles.jpeg2eps,'Enable','on')
end
%{
function save_eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'eps', '-fonts')   
else
    savefig(name, 'eps', '-fonts')
end
%}
function save_pdf_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'pdf', '-fonts')   
else
    savefig(name, 'pdf', '-fonts')
end

function save_png_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'png', '-r1200')   
else
    savefig(name, 'png', '-r1200')
end

function jpeg2eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
global PhSpGeoDir
if strcmp(name, '')
    savefig('CurrentFigure', 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 CurrentFigure.jpeg > CurrentFigure.eps'];
    eval(cmd_string)
else
    savefig(name, 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 ',name,'.jpeg > ',name,'.eps'];
    eval(cmd_string)    
end


function Help_Callback(hObject, eventdata, handles)
% do nothing

function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','on');

function EscHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','off');

function About_Callback(hObject, eventdata, handles)
About

function Credits_Callback(hObject, eventdata, handles)
Credits

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% END of CODE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
