function Y = paralfor(X)
HamiltonDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(HamiltonDir);

ext = X{1,1}; handles = X(1,2); Totalbar = X{1,3}; begin = X{1,4};
handles = handles{1,1};
global epsilon
epsilon = str2num(get(handles.edit_eps,'String'));
contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
tau_total = str2num(get(handles.edit_time,'String'));
OutStep = str2num(get(handles.step_ODE,'String'));
numstep_x = str2num(get(handles.step_1,'String'));
numstep_y = str2num(get(handles.step_2,'String'));
row_tot = numstep_y + 1;
col_tot = numstep_x + 1;
x_init = str2num(get(handles.x_in,'String'));
y_init = str2num(get(handles.y_in,'String'));
x_fin = str2num(get(handles.x_fin,'String'));
y_fin = str2num(get(handles.y_fin,'String'));
if numstep_x == 0
    step_x = 0;
else
    step_x = (x_fin - x_init)/numstep_x;
end
if numstep_y == 0
    step_y = 0;
else
    step_y = (y_fin - y_init)/numstep_y;
end
int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);
I3_o = str2num(get(handles.I3_o,'String'));
Rel_Tol = str2num(get(handles.RelTol,'String'));
Abs_Tol = str2num(get(handles.AbsTol,'String'));
Init_Step = str2num(get(handles.InStep,'String'));
Max_Step = str2num(get(handles.MaxStep,'String'));

extstr = num2str(ext);
if row_tot <= col_tot   
    x_o = x_init + step_x*(ext-1);
else
    y_o = y_init + step_y*(ext-1);    
end

ccount = 0;
for int = 1:int_tot
    if row_tot <= col_tot
        y_o = y_init + step_y*(int-1);        
    else
        x_o = x_init + step_x*(int-1);
    end
    Xo = [0;  0;  0;  x_o;  y_o;  I3_o];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if get(handles.popupHamilton,'Value') == 1
        DiffEquation = 'FGL';
    elseif get(handles.popupHamilton,'Value') == 2
        DiffEquation = 'FGLmod';
    elseif get(handles.popupHamilton,'Value') == 3
        DiffEquation = 'ERSD';        
    end
    if (strcmp(ODE, 'IRKGauss') == 1)
        opt.method = 6;
        opt.nstep = tau_total/OutStep;
        [tau,W] = eval([ODE, '(@',DiffEquation,', [0, tau_total], Xo, opt)']);
    else
        OutStep_string = num2str(OutStep);
        options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
            'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);
        [tau,W] = eval([ODE, '(''',DiffEquation,''', [0 :',OutStep_string,': tau_total], Xo, options)']);
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    data_sep = num2str(100000*OutStep);
    flag_FMFT = num2str(1);
    d = size(W(:,1),1);    
    ndata = num2str(2^(floor(log2(d))));
%%%%%%%%%%%%%%%%%%%%%
    WriteInput
%%%%%%%%%%%%%%%%%%%%%

%------------------- Frequencies ----------------------------------
    min_f = str2num(get(handles.freq1_min,'String'));
    max_f = str2num(get(handles.freq1_max,'String'));
    if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');
        nfreq = num2str(2);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_1)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(HamiltonDir)
            continue
        end        
        if abs(frq_1(1)) > 1
            freq_1(int) = frq_1(1);
        else
            freq_1(int) = frq_1(2);
        end
    else
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');         
        nfreq = num2str(1);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_1)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(HamiltonDir)
            continue
        end          
        freq_1(int) = frq_1;
    end

    min_f = str2num(get(handles.freq2_min,'String'));
    max_f = str2num(get(handles.freq2_max,'String'));
    if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');
        nfreq = num2str(2);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_2)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(HamiltonDir)
            continue
        end          
        if abs(frq_2(1)) > 1
            freq_2(int) = frq_2(1);
        else
            freq_2(int) = frq_2(2);
        end
    else
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');         
        nfreq = num2str(1);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_2)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(HamiltonDir)
            continue
        end          
        freq_2(int) = frq_2;
    end

    freq_3(int) = 0;        
    if str2num(get(handles.I3_o,'String')) ~= 0
        min_f = str2num(get(handles.freq3_min,'String'));
        max_f = str2num(get(handles.freq3_max,'String'));
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_3)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(HamiltonDir)
                continue
            end                     
            if abs(frq_3(1)) > 1
                freq_3(int) = frq_3(1);
            else
                freq_3(int) = frq_3(2);
            end          
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_3)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(HamiltonDir)
                continue
            end                     
            freq_3(int) = frq_3;               
        end
    end
%-------------- Frequency Modulation Indicator (FMI)---------------
    str_FMFT_pick = num2str(FMFT_pick);                  
%----------------------- Freq1 ------------------------------------
    n_step = str2num(get(handles.Step_FMI1,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq1_min,'String'));
        max_f = str2num(get(handles.freq1_max,'String'));        
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);                
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                
                freq(rr) = frq;
            end
        end

        freq_min_1(int) = min(freq);
        freq_max_1(int) = max(freq);

%       Set min FMI1 = -12        
        if abs((freq_max_1(int)-freq_min_1(int))/(freq_max_1(int)+freq_min_1(int))) < 1e-12
            freq_min_1(int) = 1;
            freq_max_1(int) = (1+1e-12)/(1-1e-12);
        end
    end
%--------------------- Freq2 -- -------------------------------
    n_step = str2num(get(handles.Step_FMI2,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq2_min,'String'));
        max_f = str2num(get(handles.freq2_max,'String'));        
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                     
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                     
                freq(rr) = frq;
            end
        end

        freq_min_2(int) = min(freq);
        freq_max_2(int) = max(freq);

%       Set min FMI2 = -12        
        if abs((freq_max_2(int)-freq_min_2(int))/(freq_max_2(int)+freq_min_2(int))) < 1e-12
            freq_min_2(int) = 1;
            freq_max_2(int) = (1+1e-12)/(1-1e-12);
        end          
    end
%--------------------- Freq3 ----------------------------------
    n_step = str2num(get(handles.Step_FMI3,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq3_min,'String'));
        max_f = str2num(get(handles.freq3_max,'String'));        
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);              
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                     
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if numel(frq)== 0
                    disp('Some error occurred: the corresponding FMI value will be left blank.')
                    freq = NaN;        
                    cd(HamiltonDir)
                    break
                end                     
                freq(rr) = frq;
            end
        end

        freq_min_3(int) = min(freq);
        freq_max_3(int) = max(freq);

%       Set min FMI3 = -12        
        if abs((freq_max_3(int)-freq_min_3(int))/(freq_max_3(int)+freq_min_3(int))) < 1e-12
            freq_min_3(int) = 1;
            freq_max_3(int) = (1+1e-12)/(1-1e-12);
        end
    end
%--------------------- End FMI --------------------------------------------
%---------------------------------------
    ccount = ccount + 1;
    perc = ccount/int_tot*100;
    fprintf('\n\n')
    if ccount == 1
        lgt = fprintf('\b\b%4.2f%%',perc);
    else
        fprintf(repmat('\b', 1, lgt));
        lgt = fprintf('%4.2f%%',perc) + 2;
    end
%---------------------------------------
    clear DiffEquation
end

n_step = str2num(get(handles.Step_FMI1,'String'));
if n_step >= 1
    FMI_1 = log10(abs((freq_max_1 - freq_min_1)./(freq_max_1 + freq_min_1)));
else
    FMI_1 = zeros(1, int_tot);
end

n_step = str2num(get(handles.Step_FMI2,'String'));
if n_step >= 1    
    FMI_2 = log10(abs((freq_max_2 - freq_min_2)./(freq_max_2 + freq_min_2)));
else
    FMI_2 = zeros(1, int_tot);
end

n_step = str2num(get(handles.Step_FMI3,'String'));
if n_step >= 1     
    FMI_3 = log10(abs((freq_max_3 - freq_min_3)./(freq_max_3 + freq_min_3)));
else
    FMI_3 = zeros(1, int_tot);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
compted = str2num(get(handles.count,'String'));
compted = compted + 1;
set(handles.count,'String', num2str(compted));

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = list{dim(1,1), dim(1,2)};

partial = str2num(get(handles.count,'String'));
total = max(row_tot, col_tot);
perc = partial/total;
completed = perc*100;

display('------------------------------------------------------------')
if row_tot <= col_tot
    display(['Column ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total column computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total'])
else
    display(['Row ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total row computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total']) 
end
%%%%%%%%%%%%%%%% Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%
cd ..
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','a');
        fwrite(fid,'1');
        fclose(fid);
        failure = false;
    end
end
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','r');
        A = fread(fid,'*char');
        num = str2num(A);
        failure = false;
    end
end
perc = num2str(sum(num)/ext_tot*100,'%4.2f');

cd(HamiltonDir)
list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = list{dim(1,1), dim(1,2)};
update = [curdir,' - Total progress: ', perc, '%.',' Starting time: ', begin];

try
    waitbar(sum(num)/ext_tot, Totalbar, update);
catch ME
    % do nothing
end
%--------------------------------------------------------------------------
cd(HamiltonDir)
disp(['|============= Total progress: ',perc,'% ===============|']);
disp('    ')

%%%%%%%%%%%%%%%%%%%%%% End Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Y = [freq_1; freq_2; freq_3; FMI_1; FMI_2; FMI_3];
delete *.txt
