%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Avoid visualizing the wrong waitbar
global pick
pick = tau_total;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Begin numerical computation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
S_vec_o(1) = str2num(get(handles.edit_S01,'String'));  
S_vec_o(2) = str2num(get(handles.edit_S02,'String'));
S_vec_o(3) = str2num(get(handles.edit_S03,'String'));  % Relative equilibrium
D_vec_o(1) = str2num(get(handles.edit_D01,'String'));  %      position
D_vec_o(2) = str2num(get(handles.edit_D02,'String'));
D_vec_o(3) = str2num(get(handles.edit_D03,'String'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RotS3 = S_vec_o/norma(S_vec_o);
if (S_vec_o(2)^2+S_vec_o(3)^2) == 0
    RotS2 = [0  1  0];
    RotS1 = [0  0  -1];
else
    RotS2 = [0  S_vec_o(3)/sqrt(S_vec_o(2)^2+S_vec_o(3)^2)...
        -S_vec_o(2)/sqrt(S_vec_o(2)^2+S_vec_o(3)^2)];
    RotS1 = vectorp(RotS2, RotS3);
end
RotS = [RotS1' RotS2' RotS3'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RotD3 = D_vec_o/norma(D_vec_o);
if (D_vec_o(2)^2+D_vec_o(3)^2) == 0
    RotD2 = [0  1  0];
    RotD1 = [0  0  -1];
else
    RotD2 = [0  D_vec_o(3)/sqrt(D_vec_o(2)^2+D_vec_o(3)^2)...
        -D_vec_o(2)/sqrt(D_vec_o(2)^2+D_vec_o(3)^2)];
    RotD1 = vectorp(RotD2, RotD3);
end
RotD = [RotD1' RotD2' RotD3'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
S3prime_norm_init = str2num(get(handles.edit_3D_init_S,'String'));
S3prime_norm_final = str2num(get(handles.edit_3D_final_S,'String'));
row_tot = str2num(get(handles.edit_3D_step_S,'String')) + 1;
D3prime_norm_init = str2num(get(handles.edit_3D_init_D,'String'));
D3prime_norm_final = str2num(get(handles.edit_3D_final_D,'String'));
col_tot = str2num(get(handles.edit_3D_step_D,'String')) + 1;
phiS_o =  1/2*str2num(get(handles.edit_phiR,'String'));
phiD_o = -phiS_o;

int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Integrate a single orbit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (row_tot == 1) & (col_tot == 1)
    S1 = sqrt(1 - S3prime_norm_init^2);
    S2 = 0;
    S3 = S3prime_norm_init;
    S_vec_prime = [S1  S2  S3]*[cos(pi/180*phiS_o)  sin(pi/180*phiS_o)  0;...
        -sin(pi/180*phiS_o)  cos(pi/180*phiS_o)  0;...
        0                    0           1];
    
    D1 = sqrt(1 - D3prime_norm_init^2);
    D2 = 0;
    D3 = D3prime_norm_init;
    D_vec_prime = [D1  D2  D3]*[cos(pi/180*phiD_o)  sin(pi/180*phiD_o)  0;...
        -sin(pi/180*phiD_o)  cos(pi/180*phiD_o)  0;...
        0                    0           1];
    
    S_vec = S_vec_prime*RotS';
    D_vec = D_vec_prime*RotD';
    [q_vec_o, p_vec_o] = SD2Cartesian(S_vec/2, D_vec/2);         
%-------------------------------------------------------------------------------
    lambd = lambda_tot + 1;
    clear global lambda
    kk = 0;
    while abs(lambd - lambda_tot) > 1e-02
        if kk > 50
            break
        end
        lambd = 1/sqrt(-2*(1/2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')...
            + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5)));
            
        if ~isreal(lambd)
            break
        end
            
        q_vec_o = lambda_tot^2*q_vec_o/lambd^2;
        p_vec_o = p_vec_o*lambd/lambda_tot;
        kk = kk + 1;
    end
        
    if (~isreal(lambd) | isnan(lambd))
        [q_vec_o, p_vec_o] = SD2Cartesian(S_vec_o/2, D_vec_o/2);
    end
        
    f = @(z)1/sqrt(-2*(1/2*z^2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')*z^2 ...
            + Hp(q_vec_o/z^2, p_vec_o*z, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5))) - lambda_tot;
    opts = optimset('Display','off');
    
    try
        a = fzero(f,1,opts);
    catch
        warndlg(sprintf(['With the selected value of Total Energy I am not able to find the initial conditions.']))
        return
    end

    if isnan(a)
        warndlg(sprintf(['With the selected value of Total Energy it is impossible to find ',...
          'the initial conditions for a correct value of G and G3.']))
        return
    end                  
    q_vec_o = q_vec_o/a^2;
    p_vec_o = p_vec_o*a;
    %lambda = lambda_tot;
    clear global lambda
%---------------------------------------------------------------------
    set(handles.q1_value,'String', q_vec_o(1))
    set(handles.q2_value,'String', q_vec_o(2))
    set(handles.q3_value,'String', q_vec_o(3))
    set(handles.p1_value,'String', p_vec_o(1))
    set(handles.p2_value,'String', p_vec_o(2))
    set(handles.p3_value,'String', p_vec_o(3))
    Cartesian2Keplerian

    set(handles.edit_smaxis,'String', num2str(sm_ax_o,'%5.10f'))
    set(handles.edit_Eccentricity,'String', num2str(Ecc_o,'%5.10f'))
    set(handles.edit_AscNode,'String', num2str(Omega_o,'%5.10f'))
    set(handles.edit_ArgPericenter,'String', num2str(omega_o,'%5.10f'))
    set(handles.edit_Inclination,'String', num2str(incl_o,'%5.10f'))
    set(handles.edit_TrueAnomaly,'String', num2str(f_o,'%5.10f'))

    Disable_General

    set(handles.uipanel_Freq3D_LSD, 'Visible', 'off')
    set(handles.uipanelInit, 'Visible', 'on')
    set(handles.uipanel_AA_FMFT, 'Visible', 'on')
    set(handles.uipanel_RegMethod, 'Visible', 'on')
    set(handles.uipanel_StandMethod, 'Visible', 'on')
    set(handles.uipanel_ClearMemory,'Visible', 'on')
    set(handles.radiobutton_1st,'Value', 1)
    set(handles.radiobutton_2nd,'Value', 0)
    set(handles.radiobutton_Delaunay,'Value', 0)
    set(handles.radiobutton_Delaunayprime,'Value', 0)
    set(handles.radiobutton_Pauli,'Value', 0)
    set(handles.radiobutton_Pauliprime,'Value', 1)
    ValuePert = get(handles.radiobutton_Pert_LSD,'Value');
    ValueNonPert = get(handles.radiobutton_NonPert_LSD,'Value');
    set(handles.radiobutton_Pert,'Value', ValuePert)
    set(handles.radiobutton_NonPert,'Value', ValueNonPert)
    set(handles.edit_block,'Visible', 'on')
    set(handles.text_block,'Visible', 'on')
    set(handles.popupmenu_head,'Value', 1)

    if strcmp(get(handles.LGG3_long_FMFT, 'Checked'),'on') |...
                strcmp(get(handles.LSD_long_FMFT, 'Checked'),'on')
        set(handles.uipanel_from_to,'Visible', 'off')
        set(handles.LongtimeFA,'Visible', 'on')
    else      
        set(handles.uipanel_from_to, 'Visible', 'on')
        set(handles.LongtimeFA, 'Visible', 'off')
    end    
    
    pushbutton_Integrate_Callback(hObject, eventdata, handles)
%    Integrate
    return    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             Integrate a grid of initial values
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display(['    STARTING COMPUTATION with ',ODE,'!!!'])
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isdeployed
    % do nothing
else
    if get(handles.radiobutton_Pert_LSD,'Value') == 1
        Symbolic
        Write2file
        waitfor(exist('DiffEquation'))
    elseif get(handles.radiobutton_NonPert_LSD,'Value') == 1
        SymbolicNonPert
        Write2fileNonPert
        waitfor(exist('DiffEquation'))
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if row_tot == 1
    stepS = 0;
else
    stepS = (S3prime_norm_final - S3prime_norm_init)/(row_tot - 1);
end

if col_tot == 1
    stepD = 0;
else
    stepD = (D3prime_norm_final - D3prime_norm_init)/(col_tot - 1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(ODE, 'Tom') == 1
    met = str2num(get(handles.edit_met,'String'));
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    RelTolNewt = str2num(get(handles.edit_RelTolNewt,'String'));
    Itnlmax = str2num(get(handles.edit_Itnlmax,'String'));     
    tom_options = tomgset('met',met,'Order',10,'StepSize',StepSize,...
        'RelTolNewt',RelTolNewt,...
        'Vectorized','off','OutputSteps',1,...
        'Itnlmax',Itnlmax,'Stats_step','off','Stats','off');      
    options = tom_options;
elseif (strcmp(ODE, 'RungeKutta4') == 1) | (strcmp(ODE, 'RungeKutta5') == 1)
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    tau_c = (0 : StepSize : tau_total)';
    options = struct([]);
elseif (strcmp(ODE, 'IRKGauss') == 1)    
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));     
    opt.method = str2num(get(handles.edit_IRKMeth,'String'));	
    opt.nstep = tau_total/StepSize;
    options = struct([]);
else
    Rel_Tol = str2num(get(handles.edit_RelTol,'String'));
    Abs_Tol = str2num(get(handles.edit_AbsTol,'String'));
    Init_Step = str2num(get(handles.edit_InitialStep,'String'));
    Max_Step = str2num(get(handles.edit_MaxStep,'String'));
    OutStep_string = get(handles.edit_OutputStep,'String');
    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);            
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
if ~isnan(findstr(KeplerDir, 'Slave'))
% do nothing
else
%    if strcmp(get(handles.waitbars, 'Checked'),'on')
        mainbar = waitbar(0,'Please wait..., KEPLER is calculating.');
%    else
%        mainbar = [];
%    end
end
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,12);
for ext = 1:ext_tot
    subcell{1,1} = [ext];
    subcell{1,2} = [stepS];
    subcell{1,3} = [stepD];
    subcell{1,4} = [RotS];
    subcell{1,5} = [RotD];
    subcell{1,6} = [];
    subcell{1,7} = [options];
    subcell{1,8} = [S_vec_o];
    subcell{1,9} = [D_vec_o];
    subcell{1,10} = [handles];
    subcell{1,11} = [begin];
    subcell{1,12} = [mainbar];

    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(KeplerDir)

warning('off')
resultCell = startmulticoremaster(@parfor_LSD, parameterCell, '../multicorefiles');
warning('on')
%---------------------- End multicore -----------------------------------
freq_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    freq_1 = [freq_1; resultCell{1,k}(1,:)];
end
freq_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    freq_2 = [freq_2; resultCell{1,k}(2,:)];
end
freq_3 = [resultCell{1,1}(3,:)];
for k = 2 : ext_tot
    freq_3 = [freq_3; resultCell{1,k}(3,:)];
end
FMI_1 = [resultCell{1,1}(4,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(4,:)];
end
FMI_2 = [resultCell{1,1}(5,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(5,:)];
end
FMI_3 = [resultCell{1,1}(6,:)];
for k = 2 : ext_tot
    FMI_3 = [FMI_3; resultCell{1,k}(6,:)];
end

if row_tot <= col_tot
    freq_1 = freq_1';
    freq_2 = freq_2';
    freq_3 = freq_3';
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
    FMI_3 = FMI_3';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save UserSaved/freq1.dat freq_1 -ascii
save UserSaved/freq2.dat freq_2 -ascii
save UserSaved/freq3.dat freq_3 -ascii
save UserSaved/FMI1.dat FMI_1 -ascii
save UserSaved/FMI2.dat FMI_2 -ascii
save UserSaved/FMI3.dat FMI_3 -ascii
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         
delete *.txt
%{
if ishandle(mainbar)
    close(mainbar);
end
%}
set(handles.count,'String', num2str(0));
display('-------------------------------------------------------------------')
display(['            FINISH with ',ODE,'!!!'])
toc
display('###################################################################')
set(handles.count,'String', '0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if row_tot > 1
    S3prime = S3prime_norm_init : stepS : S3prime_norm_final;
end
if col_tot > 1
    D3prime = D3prime_norm_init : stepD : D3prime_norm_final;
end

S3_str = num2str(S3prime_norm_init);
D3_str = num2str(D3prime_norm_init);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%